-- FLYSIMWARE LJ35A LINDA ACTIONS MODULE BY PASCAL PAILLART -- 30-09-2016 version1.00
-- Done especially for Saitek multi switch and Saitek multi panel and Thrustmater warthog

-- For autopilot functions please request to Al Klayton his LUA files to declare in FSUIPC
-- refer to flysimware forum on avsim: http://www.avsim.com/topic/491894-replacing-lear35a-mouse-clicks-with-keys-or-buttons/

-- ## System functions ##

function InitVars ()

  ---------------------------setup parking sets when loading

     OnGround = ipc.readUW("0366")   -- plane on ground?
     ipc.sleep(3000)
	 ipc.control(66494, 0)   -- Engine1 off
	 ipc.control(66495, 0)   -- Engine2 off
     ipc.sleep(15000)
     if OnGround == 1 then ipc.writeUW("3367", 0)      -- if on ground, close door
							ipc.writeLvar("chocks", 1) -- Chocks on
							ipc.writeLvar("YOKE", 1)   -- Yoke not hidden, replace 0 by 1 if you want it hidden
							ipc.writeLvar("parked", 1)  -- flammes and engine covers on	
							ipc.writeLvar("WINDSHIELD_SHADES", 1) -- WINDSHIELDSHADES on
							ipc.writeLvar("FUEL_SEL", 3) -- select total fuel quantity for the Fuel quantity gauge
							ipc.writeLvar("L:SW_TURB",1) -- Select engines synchro on Turbine
							ipc.writeLvar("LEAR_SHUTOFF1",1) -- fuel shutoff engine 1
							ipc.writeLvar("LEAR_SHUTOFF2",1) -- fuel shutoff engine 2
	 end  
-----------------------------------------------------------------------------------

end 


-- ## PARKING SETS ###############
-- to be use especially with magneto rotatif button on Saitek multi panel
-- OFF position (on press)= PARKING_on = Enfine covers, Shocks ans windshield shades ON
-- OFF position (on realease)= PARKING_off = Enfine covers, Shocks ans windshield shades ON
-- L position = PILOTS_out = Airplane without pilots
-- R position = PILOTS_in = Airplane with pilots no headset no sunglasses
-- Both/all position = PILOTS headset = Airplane with pilots and headsets no sunglasses
-- Start position = PILOTS sunglass = Airplane with pilots and headsets and sunglasses

function PARKING_on ()
    	ipc.writeLvar("chocks",1)              -- Chocks on
		ipc.writeLvar("parked",1)              -- Remove before flight on
		ipc.writeLvar("pilotswitch", 1) -- no Pilot
		ipc.writeLvar("pilot2switch", 0) -- no Copilot		
		ipc.writeLvar("WINDSHIELD_SHADES", 1)  -- WINDSHIELD_SHADES on
end

function PARKING_off ()
    	ipc.writeLvar("chocks",0)              -- Chocks off
		ipc.writeLvar("parked",0)              -- Remove before flight off
		ipc.writeLvar("WINDSHIELD_SHADES", 0)  -- WINDSHIELD_SHADES off
end

function PARKING_toggle ()
    if ipc.readLvar("chocks") == 1 then
        ipc.writeLvar("chocks", 0)
		ipc.writeLvar("parked",0)
		ipc.writeLvar("WINDSHIELD_SHADES", 0)
    else
        ipc.writeLvar("chocks", 1)
		ipc.writeLvar("parked",1)
		ipc.writeLvar("WINDSHIELD_SHADES", 1)
    end
end

function PILOTS_in ()
							ipc.writeLvar("pilotswitch", 0) -- Pilot in
							ipc.writeLvar("pilot2switch", 1) -- Copilot in
							ipc.writeLvar("L:headsetswitch", 0) -- Pilot without headset
							ipc.writeLvar("L:shadesswitch", 0) -- Pilot without sunglasses
end

function PILOTS_out ()
							ipc.writeLvar("pilotswitch", 1) -- no Pilot
							ipc.writeLvar("pilot2switch", 0) -- no Copilot
end


function PILOTS_sunglass ()  
							ipc.writeLvar("L:shadesswitch", 1) -- sunglasses
end

function PILOTS_headset ()  
							ipc.writeLvar("L:headsetswitch", 1) -- Pilot with headset
							ipc.writeLvar("L:shadesswitch", 0) -- Pilot without sunglasses
end

function PILOTS_headsetandsunglasses ()  
							ipc.writeLvar("L:headsetswitch", 1) -- Pilot with headset
							ipc.writeLvar("L:shadesswitch", 1) -- sunglasses
end

function CARGO_in ()
							ipc.writeLvar("luggage1", 1) -- Cargo in
end

function CARGO_out ()
							ipc.writeLvar("luggage1", 0) -- Cargo out
end

function CARGO_toggle ()
    if ipc.readLvar("luggage1") == 1 then
        ipc.writeLvar("luggage1", 0)
    else
        ipc.writeLvar("luggage1", 1)
    end
end



-- ## EXTERNAL LIGHTS ###############

function TAXI_LIGHTS_on ()
        ipc.writeLvar("L:TAXI_LAND",0)   -- turn taxi lights on 
		ipc.writeLvar("L:XMLSND70",1)  --switch sound
end

function TAXI_LIGHTS_off ()  
        ipc.writeLvar("L:TAXI_LAND",-1)   -- turn all lights off 
		ipc.writeLvar("L:XMLSND70",1)  --switch sound
end

function LANDING_LIGHTS_on ()  
        ipc.writeLvar("L:TAXI_LAND",1)   --turn landing lights on
		ipc.writeLvar("L:XMLSND70",1)  --switch sound
end

function RECO_LIGHTS_toggle ()  
		ipc.control(66377)   --recognition lights toggle control
end


-- ## INTERNAL LIGHTS ###############


function LIGHTS_on ()
    	ipc.writeLvar("LTS_PNL",5) -- Instrument lights on max
    	ipc.writeLvar("LTS_EL",5) -- Panel lights on max
    	ipc.writeLvar("LTS_FLOOD",5) -- Flood lights on max
    	ipc.writeLvar("LTS_HSI",6) -- HSI lights on max
		ipc.writeLvar("mfdbrt_GPS",7) -- GPS lights on max			
		ipc.writeLvar("L:XMLSND70",1)   -- switch sound		
end

function LIGHTS_off ()
    	ipc.writeLvar("LTS_PNL",0) -- Instrument lights off
    	ipc.writeLvar("LTS_EL",0) -- Panel lights off
    	ipc.writeLvar("LTS_FLOOD",0) -- Flood lights off
    	ipc.writeLvar("LTS_HSI",0) -- HSI lights off
		ipc.writeLvar("mfdbrt_GPS",4) -- GPS lights decreased			
		ipc.writeLvar("L:XMLSND70",1)   -- switch sound		
end


-- ## SYSTEMS ###############

function SHUTOFF1_on ()
    	ipc.writeLvar("LEAR_SHUTOFF1",1) -- fuel on	
end

function SHUTOFF1_off ()
    	ipc.writeLvar("LEAR_SHUTOFF1",0) -- fuel shutoff		
end

function SHUTOFF2_on ()
    	ipc.writeLvar("LEAR_SHUTOFF2",1) -- fuel on
end

function SHUTOFF2_off ()
    	ipc.writeLvar("LEAR_SHUTOFF2",0) -- fuel shutoff	
end


function STARTER_R_on ()
    	ipc.writeLvar("LEAR_STARTER_R",1) -- starter on
		ipc.writeLvar("L:XMLSND70",1)   -- switch sound		
end

function STARTER_R_off ()
    	ipc.writeLvar("LEAR_STARTER_R",0) -- starter off
		ipc.writeLvar("L:XMLSND70",1)   -- switch sound		
end

function STARTER_L_on ()
    	ipc.writeLvar("LEAR_STARTER_L",1) -- starter on
		ipc.writeLvar("L:XMLSND70",1)   -- switch sound		
end

function STARTER_L_off ()
    	ipc.writeLvar("LEAR_STARTER_L",0) -- starter off
		ipc.writeLvar("L:XMLSND70",1)   -- switch sound		
end


function GEN_R_on ()
    	ipc.writeLvar("LEAR_STARTER_R",-1) -- starter on
		ipc.writeLvar("L:XMLSND70",1)   -- switch sound		
end

function GEN_R_off ()
    	ipc.writeLvar("LEAR_STARTER_R",0) -- starter off
		ipc.writeLvar("L:XMLSND70",1)   -- switch sound		
end

function GEN_L_on ()
    	ipc.writeLvar("LEAR_STARTER_L",-1) -- starter on
		ipc.writeLvar("L:XMLSND70",1)   -- switch sound		
end

function GEN_L_off ()
    	ipc.writeLvar("LEAR_STARTER_L",0) -- starter off
		ipc.writeLvar("L:XMLSND70",1)   -- switch sound		
end


function REVERSERS_on ()
        ipc.writeLvar("L:REV_L",-1)                     --turn both reversers on
        ipc.writeLvar("L:REV_R",-1)		
end

function REVERSERS_off ()
        ipc.writeLvar("L:REV_L",0)                     --turn both reversers off
        ipc.writeLvar("L:REV_R",0)	
end

function STEERLOCK_on ()
		ipc.writeLvar("L:STEER_ON",1)
end

function STEERLOCK_off ()
		ipc.writeLvar("L:STEER_ON",0)
end

function STEERLOCK_toggle ()
    if ipc.readLvar("STEER_ON") == 1 then
        ipc.writeLvar("STEER_ON", 0)
    else
        ipc.writeLvar("STEER_ON", 1)
    end
end


function ENGINES_SYNCHRO_on ()
		ipc.writeLvar("L:SW_SYNC",1) --Select engines synchro on
		ipc.writeLvar("L:XMLSND70",1)  --switch sound			
end

function ENGINES_SYNCHRO_off ()
		ipc.writeLvar("L:SW_SYNC",0) --Select engines synchro off
		ipc.writeLvar("L:XMLSND70",1)  --switch sound		
end

function ENGINES_SYNCHRO_toggle ()
    if ipc.readLvar("SW_SYNC") == 1 then
        ipc.writeLvar("SW_SYNC", 0)
		ipc.writeLvar("L:XMLSND70",1)  --switch sound		
    else
        ipc.writeLvar("SW_SYNC", 1)
		ipc.writeLvar("L:XMLSND70",1)  --switch sound		
    end
end

function SYNCHRO_TURB ()
		ipc.writeLvar("L:SW_TURB",1)  -- Select engines synchro on Turbine
		ipc.writeLvar("L:XMLSND70",1)  --switch sound		
end

function SYNCHRO_FAN ()
		ipc.writeLvar("L:SW_TURB",0)   -- Select engines synchro on Fan
		ipc.writeLvar("L:XMLSND70",1)  --switch sound		
end

function SYNCHRO_toggle ()
    if ipc.readLvar("SW_TURB") == 1 then
        ipc.writeLvar("SW_TURB", 0)
		ipc.writeLvar("L:XMLSND70",1)  --switch sound		
    else
        ipc.writeLvar("SW_TURB", 1)
		ipc.writeLvar("L:XMLSND70",1)  --switch sound		
    end
end


function ANTISKID_on ()
		ipc.writeLvar("L:SW_ANTISKID",1) --Select engines synchro on
end

function ANTISKID_off ()
		ipc.writeLvar("L:SW_ANTISKID",0) --Select engines synchro off
end

function ANTISKID_toggle ()
    if ipc.readLvar("SW_ANTISKID") == 1 then
        ipc.writeLvar("SW_ANTISKID", 0)
    else
        ipc.writeLvar("SW_ANTISKID", 1)
    end
end


function PITOT_HEAT_on ()  
        ipc.writeLvar("L:PITOT_L",1)   --turn left pitot heat on
        ipc.writeLvar("L:PITOT_R",1)   --turn right pitot heat on	
        ipc.writeLvar("L:WSHLD_HEAT",-1)   --turn wshld heat on		
        ipc.writeLvar("L:WSHLD_RADOME",-1)   --turn wshld heat on			
		ipc.writeLvar("L:XMLSND70",1)  --switch sound
end

function PITOT_HEAT_off ()  
        ipc.writeLvar("L:PITOT_L",0)   --turn left pitot heat off
        ipc.writeLvar("L:PITOT_R",0)   --turn right pitot heat off	
        ipc.writeLvar("L:WSHLD_HEAT",1)   --turn wshld heat off		
        ipc.writeLvar("L:WSHLD_RADOME",1)   --turn wshld heat off			
		ipc.writeLvar("L:XMLSND70",1)  --switch sound
end

function DEICE_on ()  
        ipc.writeLvar("L:NACHEAT_L",1)   --turn left nacelle heat on
        ipc.writeLvar("L:NACHEAT_R",1)   --turn right nacelle heat on	
        ipc.writeLvar("L:WING_HEAT",1)   --turn wing heat on				
		ipc.writeLvar("L:XMLSND70",1)  --switch sound
end

function DEICE_off ()  
        ipc.writeLvar("L:NACHEAT_L",0)   --turn left nacelle heat off
        ipc.writeLvar("L:NACHEAT_R",0)   --turn right nacelle heat off	
        ipc.writeLvar("L:WING_HEAT",0)   --turn wing heat off				
		ipc.writeLvar("L:XMLSND70",1)  --switch sound
end

function AUTOPILOT_SWITCH_on ()  
        ipc.writeLvar("L:AUTOPILOT",1)   --turn autopilot power switch on
		ipc.writeLvar("L:GPS_POWER_BUTTON",1)   --turn GPS power switch on	
		ipc.writeLvar("L:XMLSND70",1)  --switch sound
end


function AUTOPILOT_SWITCH_off ()  
        ipc.writeLvar("L:AUTOPILOT",0)   --turn autopilot power switch off		
		ipc.writeLvar("L:GPS_POWER_BUTTON",0)   --turn GPS power switch on			
		ipc.writeLvar("L:XMLSND70",1)  --switch sound
end

function RDR_ALT_on ()  
        ipc.writeLvar("L:RADIO_ALT",1)   --turn radio alt switch on				
		ipc.writeLvar("L:XMLSND70",1)  --switch sound
end

function RDR_ALT_off ()  
        ipc.writeLvar("L:RADIO_ALT",0)   --turn radio alt switch on				
		ipc.writeLvar("L:XMLSND70",1)  --switch sound
end

function FUEL_PUMPS_on ()  
        ipc.writeLvar("L:SW_COMPLEFT",1)		
		ipc.writeLvar("L:SW_COMPRIGHT",1)
        ipc.writeLvar("L:FUEL_SECPUMP1",1)		
		ipc.writeLvar("L:FUEL_SECPUMP2",1)
        ipc.writeLvar("L:FUEL_MAINPUMP1",1)		
		ipc.writeLvar("L:FUEL_MAINPUMP2",1)		
		ipc.writeLvar("L:XMLSND70",1)  --switch sound
end

function FUEL_PUMPS_off ()  
        ipc.writeLvar("L:SW_COMPLEFT",0)		
		ipc.writeLvar("L:SW_COMPRIGHT",0)
        ipc.writeLvar("L:FUEL_SECPUMP1",0)		
		ipc.writeLvar("L:FUEL_SECPUMP2",0)
        ipc.writeLvar("L:FUEL_MAINPUMP1",0)		
		ipc.writeLvar("L:FUEL_MAINPUMP2",0)		
		ipc.writeLvar("L:XMLSND70",1)  --switch sound
end


function FUEL_XFER_on ()  
        ipc.writeLvar("L:FUEL_XFER",-1)   		
		ipc.writeLvar("L:XMLSND72",1)  --switch sound
end

function FUEL_XFER_off ()  
        ipc.writeLvar("L:FUEL_XFER",0)   		
		ipc.writeLvar("L:XMLSND72",1)  --switch sound
end

function INVERTERS_on ()  
        ipc.writeLvar("L:INV_PRI",1)
		ipc.writeLvar("L:INV_SEC",1)
		ipc.writeLvar("L:XMLSND70",1)  --switch sound
end


function INVERTERS_of ()  
        ipc.writeLvar("L:INV_PRI",0)
		ipc.writeLvar("L:INV_SEC",0)
		ipc.writeLvar("L:XMLSND70",1)  --switch sound
end

function BATTERIES_on ()  
        ipc.writeLvar("L:BATT1",1)   
        ipc.writeLvar("L:BATT2",1)  		
		ipc.writeLvar("L:XMLSND70",1)  --switch sound
end

function BATTERIES_off ()  
        ipc.writeLvar("L:BATT1",0)   
        ipc.writeLvar("L:BATT2",0)  		
		ipc.writeLvar("L:XMLSND70",1)  --switch sound
end


function ANTISKID_on ()  
        ipc.writeLvar("L:SW_ANTISKID",1)   		
		ipc.writeLvar("L:XMLSND70",1)  --switch sound
end

function ANTISKID_off ()  
        ipc.writeLvar("L:SW_ANTISKID",0)   		
		ipc.writeLvar("L:XMLSND70",1)  --switch sound
end

function STALL_R_on ()  
        ipc.writeLvar("L:STALL_R",1)   		
		ipc.writeLvar("L:XMLSND70",1)  --switch sound
end

function STALL_R_off ()  
        ipc.writeLvar("L:STALL_R",0)   		
		ipc.writeLvar("L:XMLSND70",1)  --switch sound
end

function STALL_L_on ()  
        ipc.writeLvar("L:STALL_L",1)   		
		ipc.writeLvar("L:XMLSND70",1)  --switch sound
end

function STALL_L_off ()  
        ipc.writeLvar("L:STALL_L",0)   		
		ipc.writeLvar("L:XMLSND70",1)  --switch sound
end

function BOTH_STALL_on ()  
        ipc.writeLvar("L:STALL_R",1) 
        ipc.writeLvar("L:STALL_L",1)  		
		ipc.writeLvar("L:XMLSND70",1)  --switch sound
end

function BOTH_STALL_off ()  
        ipc.writeLvar("L:STALL_R",0)  
        ipc.writeLvar("L:STALL_L",0) 		
		ipc.writeLvar("L:XMLSND70",1)  --switch sound
end


function MASTER_RESET_on ()  
        ipc.writeLvar("MASTER_RESET1",1)   		
		ipc.writeLvar("L:XMLSND70",1)  --switch sound
end

function MASTER_RESET_off ()  
        ipc.writeLvar("MASTER_RESET1",0)   		
end